<?php
namespace Teknisa\PLA\Modules\Cardapio\Controllers;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;

class Pla67000AgrupamentoSubstituicaoCardapio extends \Teknisa\GER\Controllers\TeknisaCrud {

    protected $crudService;
    protected $parameterBag;
    protected $util;

	public function __construct($crudService, $parameterBag, $util) {
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->util = $util;
    }
    
    public function saveAgrupamento(DTO\Request\Row $request, DTO\Response $response) {
        try {
            $this->dataSourceName = "gruposubscard";
            $row = $request->getRow();

            if ($row["__is_new"]) {
                $this->util->validateDuplicatedRecords($row, $this->dataSourceName, array("CDGRUPOSUBSCARD"));
            }
            parent::save($request, $response);
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
    
     public function saveServico(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            $this->dataSourceName = "itgruposubscard";
            $data = $request->getDataSet()->getRows();
            $rowsToSave = [];
            $rowsNotSaved = [];
            foreach ($data as $row){
                if($this->validateDuplicatedRecords($row, $this->dataSourceName, array("NRGRUPOSUBSCARD","CDFILIAL","CDSERVFILI"))){
                 array_push($rowsToSave,$row);
                }else{
                array_push($rowsNotSaved,$row);
                }    
            }
            
            $dataSet = new DataSet($this->dataSourceName, $rowsToSave);
            $newRequest = new DTO\Request\DataSet($dataSet, "", "","");
            
            $response->addDataSet(new DataSet("naoSalvos", $rowsNotSaved));
            parent::save($newRequest, $response);
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
    
    public function validateDuplicatedRecords($row, $dataSourceName, $columns) {
        $conditions = array();
        foreach ($columns as $column) {
            array_push($conditions, array(
                "columnName" => $column,
                "operator"   => '=',
                "value"      => $row[$column]
            ));
        }
        $dataSet = $this->crudService->getFilteredDataSet($dataSourceName, $conditions);

        if (!empty($dataSet->getRows())) {
            return false;
        }
        
        return true;
    }
}